/*
 ******************************************************************************
 *
 * @file     VOX_Module.c
 * @brief    VOL/R module
 *                 
 *
 * @version  1.0
 * @date     2022/07/18   09:59:40
 * @author   Alex Xu
 *
 * Copyright (c) 2013-2099,Tkplusemi Technology Co.,Ltd.
 * All Rights Reserved
 *
 * History:
 * Revision          Date           Author            Desc
 * 1.0.0            2022/07/18      Alex          build this file
 ******************************************************************************
 */
#include "vox_module.h"
#include "led.h"
#include "system.h"
#include "discharge_module.h"
#include "sleep.h"
#include "userapp.h"

bit Vor_Vout_Enable = OFF;		//OFF:BOOSTʱVOUTTRUE:ж绹IOFF硣
bit Vol_Vout_Enable = OFF;	

#if VOX_ENABLE

/******************************************************************************\
                          Macro definitions
\******************************************************************************/
#define VOX_IOFF_DET_DEBOUNCE		40			//Vox Ioffʱ4sΪ˱֤˳ʼɣʼ

#define VOX_LOADON_DET_DEBOUNCE		2

#define T10MIN_DEBOUNCE				150		//10Ӷʱ4sһΡ150
/******************************************************************************\
                             Variables definitions
\******************************************************************************/
Vox_State_e Vol_State = VOX_NONE_IN_BOX;

//uint8_t Vol_Loadon_Det_Debounce = 0;
uint8_t Vol_Ioff_Det_Debounce = 0;
//uint8_t Vol_LiPro_Det_Debounce = 0;
//bit Vol_LiPro_Flag = 0;

Vox_State_e Vor_State = VOX_NONE_IN_BOX;

//uint8_t Vor_Loadon_Det_Debounce = 0;
uint8_t Vor_Ioff_Det_Debounce = 0;
//uint8_t Vor_LiPro_Det_Debounce = 0;
//bit Vor_LiPro_Flag = 0;	

uint8_t Vol_Output_Short_Debounce = 0;
uint8_t Vor_Output_Short_Debounce = 0;

bit Vol_Bat_Full_Flag = 0;
bit Vor_Bat_Full_Flag = 0;

/******************************************************************************\
                             Functions definitions
\******************************************************************************/

/*
 *******************************************************************************
 *             void Vox_init(void)
 *
 * Description : Vox Initialization :Voxʼ
 *
 * Arguments   : NONE

 * Returns     : NONE

 * Notes       : NONE
 *
 *******************************************************************************
 */
 #if 0
void Vox_init(void)
{
	VOX_CTL0 = 0xC3;	   //VOX ؽ롢ʶʹܣԶʶ𡣴Vox vdsǯѹʹܣҪVOX 5V
/*
	SFRADDR = VOX_CON0;    //VOX500mAʶ2.5uA
	SFRDATA &= 0xE0;
	SFRDATA |= (VOX_IOUT_500MA << 3) | VOX_ADT_Cur_2_5UA;
*/	
	Vol_State = VOX_NONE_IN_BOX;

	Vor_State = VOX_NONE_IN_BOX;
}
#endif
#if 0
/*
*******************************************************************************
* 			uint8_t VOL_EN_Type(VOL_Enable_Type_e VOL_Enable_Type)
*
* Description : VOL Open(EN_VO)

* Arguments	:

* Returns 	:

* Notes		:
*
*******************************************************************************
*/
 
void VOL_EN_Type(VOX_Enable_Mode_e VOL_Enable_Mode)
{
	if(VOL_Enable_Mode == VOX_VOUT_Mode )
	{
		VOX_CTL0 &= ~0x10;		//VOL Disable 5V And Enable VOR ADT
		
		VOX_CTL0 |= 0x10;		//VOL Enable 5V   
	}
	else
	{

		VOX_CTL0 &= ~0x10;	//VOL 5v Off	
	}	
}

/*
*******************************************************************************
*			 void VOR_EN_Type(VOR_Enable_Type_e VOR_Enable_Type)
*
* Description : VOL Open(EN_VO)

* Arguments	 :

* Returns	 :

* Notes		 :
*
*******************************************************************************
*/
 void VOR_EN_Type(VOX_Enable_Mode_e VOR_Enable_Mode)
 { 

	if(VOR_Enable_Mode == VOX_VOUT_Mode )
	{
		VOX_CTL0 &= ~0x20;		//VOR Disable 5V And Enable VOR ADT
		
		VOX_CTL0 |= 0x20;		//VOR Enable 5V   
	}
	else
	{

		VOX_CTL0 &= ~0x20;	//VOR 5v Off	
	}
 }
#endif

/*
*******************************************************************************
*			 void Vol_Det_Machine(void)
*
* Description : Vol Detect:ʶ (100ms)
*
* Arguments	 : NONE

* Returns	 : NONE

* Notes		 : NONE
*
*******************************************************************************
*/
#if DISPLAY_6PIN_188
bit Vol_Outbox_Disp_Flag = 0;
bit Vol_Intobox_Disp_Flag = 0;

#endif
void Vol_Det_Machine(void)
{
	if( gBoost_Prepared_Flag )	
	{
		switch( Vol_State )
		{
			case VOX_GET_INTO_BOX:				//

				if( (VOX_CTL0 & 0x10) != 0x10 )			//1ǰѾVOUTظԭʹVOUTǰҪȹرVOUTʹܣһʱϿ
				{
					VOX_CTL0 &= ~0x10;		//VOL Disable 5V And Enable VOR ADT
					VOX_CTL0 |= 0x10;		//VOL Enable 5V   
				}

				Vol_State = VOX_STAY_IN_BOX;
			break;
			
			case VOX_STAY_IN_BOX:				//ڲ
			
				if( (CHIP_STA1 & 0x24) == 0x24 )						//VoxڳгLoadonIOFFͬʱڵ״̬1֣2س3ﮱ
				{
#if DISPLAY_6PIN_188				
					if( Vol_Intobox_Disp_Flag )         //γӦͼһ
					{
						Vol_Intobox_Disp_Flag = 0;
						Vol_GetOut_Box_Flag = 1;			//б־1
						//LED_On_Timer = 0;				
						Vol_Outbox_Disp_Flag = 1;
					}
#endif					
					Vol_Ioff_Det_Debounce++;
					if( Vol_Ioff_Det_Debounce >= VOX_IOFF_DET_DEBOUNCE )			//ת(ֺ)ʱ4s
					{
						Vol_Ioff_Det_Debounce = 0;

						//if( ON == Vol_Vout_Enable ) 					//VoxгIOFF״̬˵1֣2س
						{	
							VOX_CTL0 &= ~0x10;		//VOL Disable 5V And Enable VOR ADT
							Vol_Bat_Full_Flag = 1;
#ifdef _DEBUG_VOX
							printf("Vol Get Out\r\n");
#endif	
						
						}							
					}
				}
				else
				if( (CHIP_STA1 & 0x24) == 0x20 )						//۲CHIP_STA1״̬IOFFLoadon˵1ֺ4sڣٴ֣210δ˳ﮱ״̬磻
				{									
					Vol_Ioff_Det_Debounce = 0;
					Vol_Vout_Enable = ON;						//־ON		
					
#if DISPLAY_6PIN_188		

					if( Vol_Outbox_Disp_Flag )						//4sٴУӦͼһ
					{
						Vol_Outbox_Disp_Flag = 0;
						Vol_GetOut_Box_Flag = 0;
						Disp_Vol_Lev = Disp_Vor_Lev;
						//LED_On_Timer = 0;							
					}

					Vol_Intobox_Disp_Flag = 1;				
					
#endif
					if( Vol_Bat_Full_Flag )			//ADTģʽ£ֻLoadon״̬˵
					{
						Vol_Vout_Enable = OFF;
						
#if DISPLAY_6PIN_188
						LED_On_Timer = 0;
#endif						
#ifdef _DEBUG_VOX
						printf("Vol Bat Full\r\n");
#endif	
					}
					
				}
				else
				if( !(CHIP_STA1 & 0x24) )		//CHIP_STA1loadonioff״̬˵ˡ
				{
					Vol_State = VOX_NONE_IN_BOX; 
#if DISPLAY_6PIN_188					
					Vol_GetInto_Box_Flag = 0;
#endif
					Vol_Bat_Full_Flag = 0;
				}
				
			break;

			case VOX_NONE_IN_BOX:				//ղ
			
				//VOL_EN_Type(VOX_ADT_Mode);
				VOX_CTL0 &= ~0x10;		//VOL Disable 5V And Enable VOR ADT
				
				//Vol_Loadon_Det_Debounce = 0;
				Vol_Ioff_Det_Debounce = 0;
				Vol_Vout_Enable = OFF;
			
				if( CHIP_STA1 & 0x20 )    //ADTģʽ³Loadonźţ˵ж֡
				{			
					Vol_State = VOX_GET_INTO_BOX;
					
#if DISCHARGE_ENABLE	
					BST_EN = 1; 		//Boost Enable쳣ʱӲرա	
#endif

#if DISPLAY_6PIN_188
					Vol_GetInto_Box_Flag = 1;
					Disp_Vol_Lev = Disp_Vor_Lev;

					//LED_On_Timer = 0;	
#endif

#ifdef _DEBUG_VOX
					printf("VO_INTO_BOX\r\n");
#endif					
				}
				
			break;

			default:
			break;
		}	
	}
	else			//BoostVOXָ״̬
	{
		Vol_State = VOX_NONE_IN_BOX;
	}

	/*Vol ÿ200msһ*/
	if( IRQ_FLAG0 & 0x04 )
	{		
		Vol_Output_Short_Debounce++;
		if( Vol_Output_Short_Debounce >= 2 )		//Vor·200ms¿ADT
		{
			Vol_Output_Short_Debounce = 0;
			IRQ_FLAG0 = 0x04;
			Vol_State = VOX_NONE_IN_BOX;
		}
	}	

}

/*
*******************************************************************************
*			 void Vor_Det_Machine(void)
*
* Description : Vor Detect:ʶ (100ms)
*
* Arguments	 : NONE

* Returns	 : NONE

* Notes		 : NONE
*
*******************************************************************************
*/
#if DISPLAY_6PIN_188
bit Vor_Outbox_Disp_Flag = 0;
bit Vor_Intobox_Disp_Flag = 0;
#endif
void Vor_Det_Machine(void)
{	
	if( gBoost_Prepared_Flag )	
	{
		switch( Vor_State )
		{
			case VOX_GET_INTO_BOX:				//

				if( (VOX_CTL0 & 0x20) != 0x20 )			//1ǰѾVOUTظԭʹVOUTǰҪȹرVOUTʹܣһʱϿ
				{			
					VOX_CTL0 &= ~0x20;		//VOR Disable 5V And Enable VOR ADT
					VOX_CTL0 |= 0x20;		//VOR Enable 5V   
				}
				Vor_State = VOX_STAY_IN_BOX;
				
			break;
			
			case VOX_STAY_IN_BOX:				//ڲ
				
				if( (CHIP_STA1 & 0x88) == 0x88 )						//VoxڳгLoadonIOFFͬʱڵ״̬˵1֣2س3ﮱ
				{
#if DISPLAY_6PIN_188				
					if( Vor_Intobox_Disp_Flag )     //
					{
						Vor_Intobox_Disp_Flag = 0;
						Vor_GetOut_Box_Flag = 1;						//Ҷб־1
						//LED_On_Timer = 0;		
						Vor_Outbox_Disp_Flag = 1;
					}
#endif									
					Vor_Ioff_Det_Debounce++;
					if( Vor_Ioff_Det_Debounce >= VOX_IOFF_DET_DEBOUNCE )			//ת(ֺ)ʱ4s
					{
						Vor_Ioff_Det_Debounce = 0;
			
						//if( ON == Vor_Vout_Enable )						//VoxгIOFF״̬˵1֣2س
						{
							VOX_CTL0 &= ~0x20;		//VOR Disable 5V And Enable VOR ADT

							Vor_Bat_Full_Flag = 1;

#ifdef _DEBUG_VOX
							printf("Vor Get Out\r\n");
#endif						
						}
																							
					}
				}
				else
				if( (CHIP_STA1 & 0x88) == 0x80 )						//۲CHIP_STA1״̬IOFFLoadon˵1ֺ4sڣٴ֣210δ˳ﮱ״̬磻3ﮱ10ӡ
				{				
					Vor_Ioff_Det_Debounce = 0;
					Vor_Vout_Enable = ON;
					
#if DISPLAY_6PIN_188	
					if( Vor_Outbox_Disp_Flag )						//4sٴУӦͼһ
					{
						Vor_Outbox_Disp_Flag = 0;
						Vor_GetOut_Box_Flag = 0;
						Disp_Vor_Lev = Disp_Vol_Lev;
					}

					Vor_Intobox_Disp_Flag = 1;
#endif
					if( Vor_Bat_Full_Flag )
					{
						Vor_Vout_Enable = OFF;
#if DISPLAY_6PIN_188
						LED_On_Timer = 0;
#endif
						
#ifdef _DEBUG_VOX
						printf("Vor Bat Full\r\n");
#endif
					}
				}
				else
				if( !(CHIP_STA1 & 0x88) )		//CHIP_STA1loadonioff״̬˵ˡ
				{
					Vor_State = VOX_NONE_IN_BOX; 
#if DISPLAY_6PIN_188					
					Vor_GetInto_Box_Flag = 0;
#endif
					Vor_Bat_Full_Flag = 0;
				}

			break;

			case VOX_NONE_IN_BOX:				//ղ

				VOX_CTL0 &= ~0x20;		//VOR Disable 5V And Enable VOR ADT
				
				Vor_Ioff_Det_Debounce = 0;
				Vor_Vout_Enable = OFF;
				
				/* Loadon״̬λڣ˵̡֣*/
				if( CHIP_STA1 & 0x80 )
				{			
					Vor_State = VOX_GET_INTO_BOX;
					
#if DISCHARGE_ENABLE	
					BST_EN = 1; 		//Boost Enable쳣ʱӲرա	
#endif
#if DISPLAY_6PIN_188

					Vor_GetInto_Box_Flag = 1;
					Disp_Vor_Lev = Disp_Vol_Lev;

#endif	

#ifdef _DEBUG_VOX
					printf("VOR_INTO_BOX\r\n");
#endif					
				}
				
			break;

			default:
			break;
		}
	}
	else			//BoostVOXָ״̬
	{
		Vol_State = VOX_NONE_IN_BOX;
	}

	/*Vor (жϱ־λ)ÿ200msһ*/
	if( IRQ_FLAG0 & 0x08 )
	{		
		Vor_Output_Short_Debounce++;
		if( Vor_Output_Short_Debounce >= 2 )		//Vor·200ms¿ADT
		{
			Vor_Output_Short_Debounce = 0;
			IRQ_FLAG0 = 0x08;
			Vor_State = VOX_NONE_IN_BOX;
		}
	}	

}

#endif

